<?php
/**
 * Created by PhpStorm.
 * User: Administrator
 * Date: 25/12/2015
 * Time: 2:22 CH
 */
if (!defined('BASEPATH')) exit('No direct script access allowed');

class CmsStatistic extends CI_Controller
{
    protected $_data;
    public function __construct()
    {
        parent::__construct();
        date_default_timezone_set("Asia/Ho_Chi_Minh");
        //
        $this->load->model('muser');
        $this->load->model('mgame');
        $this->load->model('mgamedetails');
        $this->load->model('mcontest');
        $this->load->model('mlink_clicked');
    }

    /**
     * -----------------------------------------------------------------------------------------------------------------
     * Thống kê DS các lần chơi
     */
    public function listGame()
    {
        $this->_data['functionName'] = 'QL Các lần chơi';
        $this->_data['action'] = 'listGame';
        $this->_data['titlePage'] = 'QL Các lần chơi';
        $this->_data['loadPage'] = 'backend/cms_statistic/list_game_view';
        $this->load->view('backend/admin_template_view', $this->_data);
    }

    public function listGameAjax()
    {
        $data = array();
        $fByName = $this->input->post('fByName');
        $pageId = $this->input->post('pageId');
        //
        $pageId = ($pageId == 0) ? 1 : $pageId;
        //
        $limit = 10;
        $offset = ($pageId - 1) * $limit;
        $data['offset'] = ($pageId - 1) * $limit;
        $totalRecord = $this->mgamedetails->cmsCountAll2($fByName);
        $data['pagination'] = MyHelper::genPaginationLink($totalRecord, $limit, $pageId);
        $data['listData'] = $this->mgamedetails->cmsGetPagination2($limit, $offset, $fByName);
        //
        $this->load->view('backend/ajax/cms_statistic/list_game_view', $data);
    }

    /**
     * -----------------------------------------------------------------------------------------------------------------
     * Thống kê top
     */
    public function listTop()
    {
        $this->_data['functionName'] = 'QL Top 10';
        $this->_data['action'] = 'listTop';
        $this->_data['titlePage'] = 'QL Top 10';
        $this->_data['loadPage'] = 'backend/cms_statistic/list_top_view';
        $this->load->view('backend/admin_template_view', $this->_data);
    }

    public function listTopAjax()
    {
        $data = array();
        $fByDate = $this->input->post('fByDate');
        $fByName = $this->input->post('fByName');
        $pageId = $this->input->post('pageId');
        //
        $pageId = ($pageId == 0) ? 1 : $pageId;
        if($fByDate == '' || $fByDate == null){
            $fByDate = date('Y-m-d');
        }else{
            $fByDate = date('Y-m-d', strtotime($fByDate));
        }
        //
        $limit = 10;
        $offset = ($pageId - 1) * $limit;
        $data['offset'] = ($pageId - 1) * $limit;
        //$totalRecord = $this->mgamedetails->cmsCountAll3($fByName);
        //$data['pagination'] = MyHelper::genPaginationLink($totalRecord, $limit, $pageId);
        //$data['listData'] = $this->mgamedetails->cmsGetPagination3($limit, $offset, $fByName);
        $this->load->model('mgame_details');
        //$data['listData'] = $this->mgame_details->getTopByDate($limit, $offset, $fByDate, $fByName);
        $data['listData'] = $this->mgame_details->getTopByDateInOneGame($limit, $offset, $fByDate, $fByName);
        //
        $this->load->view('backend/ajax/cms_statistic/list_top_view', $data);
    }

    /**
     * -----------------------------------------------------------------------------------------------------------------
     * Thống kê top
     */
    public function listTopWeek()
    {
        // Lay tong so ngay chay chuong trinh
        $contest = $this->mcontest->getCurrentContest();
        if($contest){
            $this->_data['date_limit'] = $contest[0]['date_limit'];
        }else{
            $this->_data['date_limit'] = 28;
        }
        //
        $this->_data['functionName'] = 'QL Top 1 trong tuần';
        $this->_data['action'] = 'listTopWeek';
        $this->_data['titlePage'] = 'QL Top 1 trong tuần';
        $this->_data['loadPage'] = 'backend/cms_statistic/list_top_week_view';
        $this->load->view('backend/admin_template_view', $this->_data);
    }

    /**
     * -----------------------------------------------------------------------------------------------------------------
     * Thống kê người chơi
     */
    public function listUser()
    {
        $this->_data['functionName'] = 'QL Người chơi';
        $this->_data['action'] = 'listUser';
        $this->_data['titlePage'] = 'QL Người chơi';
        $this->_data['loadPage'] = 'backend/cms_statistic/list_user_view';
        $this->load->view('backend/admin_template_view', $this->_data);
    }

    public function listUserAjax()
    {
        $data = array();
        $fByName = $this->input->post('fByName');
        $pageId = $this->input->post('pageId');
        //
        $pageId = ($pageId == 0) ? 1 : $pageId;
        //
        $limit = 10;
        $offset = ($pageId - 1) * $limit;
        $data['offset'] = ($pageId - 1) * $limit;
        $totalRecord = $this->muser->cmsCountAll2($fByName);
        $data['pagination'] = MyHelper::genPaginationLink($totalRecord, $limit, $pageId);
        $data['listData'] = $this->muser->cmsGetPagination2($limit, $offset, $fByName);
        //
        $this->load->view('backend/ajax/cms_statistic/list_user_view', $data);
    }

    /**
     * -----------------------------------------------------------------------------------------------------------------
     * Thống kê DS các lần Người chơi click vào link
     */
    public function listUserClick()
    {
        $this->_data['functionName'] = 'QL Các lần chơi';
        $this->_data['action'] = 'listGame';
        $this->_data['titlePage'] = 'QL Các lần chơi';
        $this->_data['loadPage'] = 'backend/cms_statistic/list_user_click_view';
        $this->load->view('backend/admin_template_view', $this->_data);
    }

    public function listUserClickAjax()
    {
        $data = array();
        $fByName = $this->input->post('fByName');
        $pageId = $this->input->post('pageId');
        //
        $pageId = ($pageId == 0) ? 1 : $pageId;
        //
        $limit = 10;
        $offset = ($pageId - 1) * $limit;
        $data['offset'] = ($pageId - 1) * $limit;
        $totalRecord = $this->mlink_clicked->cmsCountAll($fByName);
        $data['pagination'] = MyHelper::genPaginationLink($totalRecord, $limit, $pageId);
        $data['listData'] = $this->mlink_clicked->cmsGetPagination($limit, $offset, $fByName);
        //
        $this->load->view('backend/ajax/cms_statistic/list_user_click_view', $data);
    }

    /**
     * -----------------------------------------------------------------------------------------------------------------
     * Xuất file mã dự thưởng
     */
    public function listExport()
    {
        try {
            // Thiết lập mặc định
            $this->load->library('excel');
            $maxRow = 1000;
            $sheetPwd = MyHelper::genExportPassword();
            // Lấy khoảng thời gian từ form submit
            $totalRecord = $this->muser->exportCountAll();
            $numSheet = ceil($totalRecord / $maxRow);

            // Xử lý dữ liệu
            if ($numSheet >= 1) {
                //1.SHEET chi tiết theo phân trang =========================================================================
                for ($sh = 0; $sh < $numSheet; $sh++) {
                    $this->excel->createSheet($sh + 1);
                    $this->excel->setActiveSheetIndex($sh + 1);
                    $this->excel->getActiveSheet()->setShowGridlines(false);
                    $this->excel->getActiveSheet()->setTitle('User-' . ($sh + 1));
                    //
                    $this->excel->getActiveSheet()->getDefaultStyle()->getFont()->setName('Times New Roman');
                    $this->excel->getActiveSheet()->getDefaultStyle()->getFont()->setSize('12');
                    $this->excel->getActiveSheet()->getColumnDimension('A')->setWidth('8'); //STT
                    $this->excel->getActiveSheet()->getColumnDimension('B')->setWidth('20'); //Tên hiển thị
                    $this->excel->getActiveSheet()->getColumnDimension('C')->setWidth('30'); //Tài khoản
                    $this->excel->getActiveSheet()->getColumnDimension('D')->setWidth('30'); //Email
                    $this->excel->getActiveSheet()->getColumnDimension('E')->setWidth('15'); //SĐT
                    $this->excel->getActiveSheet()->getColumnDimension('F')->setWidth('20'); //Mã dự thưởng
                    //
                    $this->excel->getActiveSheet()->setCellValue('A1', 'Công ty CP DV BĐS Ngôi Sao Toàn Cầu ');
                    $this->excel->getActiveSheet()->setCellValue('E1', 'THỐNG KÊ MÃ DỰ THƯỞNG');
                    $this->excel->getActiveSheet()->getStyle('A1:E1')->getFont()->setSize(15);
                    $this->excel->getActiveSheet()->getStyle('A1:E1')->getFont()->setBold(true);
                    $this->excel->getActiveSheet()->mergeCells('A1:D1');
                    $this->excel->getActiveSheet()->mergeCells('E1:G1');
                    $this->excel->getActiveSheet()->getStyle('A1:E2')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
                    //
                    $this->excel->getActiveSheet()->setCellValue('A2', '(Thành viên của Cenland)');
                    $this->excel->getActiveSheet()->setCellValue('E2', '(Hệ thống quản lý Game)');
                    $this->excel->getActiveSheet()->mergeCells('A2:D2');
                    $this->excel->getActiveSheet()->mergeCells('E2:G2');
                    $styleArray = array(
                        'font' => array(
                            'underline' => PHPExcel_Style_Font::UNDERLINE_SINGLE
                        )
                    );
                    $this->excel->getActiveSheet()->getStyle('A2:E2')->applyFromArray($styleArray);
                    //
                    $this->excel->getActiveSheet()->setCellValue('A5', 'Thời điểm xuất thống kê');
                    $this->excel->getActiveSheet()->setCellValue('A6', 'Người xuất thống kê');
                    //
                    $this->excel->getActiveSheet()->setCellValue('C5', ': ' . date('d/m/Y H:i:s'));
                    $this->excel->getActiveSheet()->setCellValue('C6', ': ' . $this->session->userdata('username'));
                    //
                    $this->excel->getActiveSheet()->setCellValue('A8', 'TT');
                    $this->excel->getActiveSheet()->setCellValue('B8', 'Tên hiển thị');
                    $this->excel->getActiveSheet()->setCellValue('C8', 'Tên tài khoản');
                    $this->excel->getActiveSheet()->setCellValue('D8', 'Email');
                    $this->excel->getActiveSheet()->setCellValue('E8', 'Số điện thoại');
                    $this->excel->getActiveSheet()->setCellValue('F8', 'Mã dự thưởng');
                    //
                    $this->excel->getActiveSheet()->duplicateStyleArray(
                        array(
                            'fill' => array(
                                'type' => PHPExcel_Style_Fill::FILL_SOLID,
                                'color' => array('rgb' => '#ffb752')
                            ),
                            'borders' => array(
                                'allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN)
                            ),
                            'font' => array('bold' => true),
                            'alignment' => array(
                                'horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER,
                                'vertical' => PHPExcel_Style_Alignment::HORIZONTAL_CENTER
                            )
                        ),
                        "A8:F8"
                    );
                    //
                    $subData = $this->muser->exportGetPagination($maxRow, $sh * $maxRow);
                    $index = 8;
                    foreach ($subData as $key => $subItem) {
                        $index += 1;
                        // 1.STT ------------------------------------------------------------------------------------------
                        $this->excel->getActiveSheet()->setCellValueExplicit('A' . $index, ($sh * $maxRow + $key + 1), PHPExcel_Cell_DataType::TYPE_NUMERIC);
                        // 2.ID, SID -----------------------------------------------------------------------------------
                        $this->excel->getActiveSheet()->setCellValueExplicit('B' . $index, $subItem['fullname'], PHPExcel_Cell_DataType::TYPE_STRING);
                        // 3.Msisdn -----------------------------------------------------------------------------------
                        $this->excel->getActiveSheet()->setCellValueExplicit('C' . $index, $subItem['username'], PHPExcel_Cell_DataType::TYPE_STRING);
                        // 4.Username -----------------------------------------------------------------------------------
                        $this->excel->getActiveSheet()->setCellValueExplicit('D' . $index, $subItem['email'], PHPExcel_Cell_DataType::TYPE_STRING);
                        // 5.Channel -----------------------------------------------------------------------------------
                        $this->excel->getActiveSheet()->setCellValueExplicit('E' . $index, $subItem['mobile'], PHPExcel_Cell_DataType::TYPE_STRING);
                        // 7.Ngày tạo ------------------------------------------------------------------------------------------
                        $this->excel->getActiveSheet()->setCellValueExplicit('F' . $index, $subItem['reward_code'], PHPExcel_Cell_DataType::TYPE_STRING);

                        // Định dạng vùng dữ liệu
                        $this->excel->getActiveSheet()->duplicateStyleArray(
                            array(
                                'alignment' => array('horizontal' => PHPExcel_Style_Alignment::HORIZONTAL_LEFT),
                                'borders' => array(
                                    'allborders' => array('style' => PHPExcel_Style_Border::BORDER_THIN)
                                ),
                            ),
                            "A" . $index . ":F" . $index
                        );
                        // Căn lề các ô, cột dữ liệu
                        $this->excel->getActiveSheet()->getStyle('A' . $index)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
                        $this->excel->getActiveSheet()->getStyle('B' . $index)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);
                        $this->excel->getActiveSheet()->getStyle('C' . $index)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);
                        $this->excel->getActiveSheet()->getStyle('D' . $index)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);
                        $this->excel->getActiveSheet()->getStyle('E' . $index)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_RIGHT);
                        $this->excel->getActiveSheet()->getStyle('F' . $index)->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
                    }

                    // Thiết lập mật khẩu cho sheet
                    $this->excel->setActiveSheetIndex($sh+1);
                    $this->excel->getActiveSheet()->getProtection()->setSheet(true);
                    $this->excel->getActiveSheet()->getProtection()->setSort(true);
                    $this->excel->getActiveSheet()->getProtection()->setPassword($sheetPwd);
                }

                // Download file ------------------------------------------------------------------------------------------
                $filename = date('Ymd_His_') . $sheetPwd . '_MaDuThuong.xls'; //save our workbook as this file name
                header('Content-Type: application/vnd.ms-excel'); //mime type
                header('Content-Disposition: attachment;filename="' . $filename . '"'); //tell browser what's the file name
                header('Cache-Control: max-age=0'); //no cache
                $objWriter = PHPExcel_IOFactory::createWriter($this->excel, 'Excel5');
                $objWriter->save('php://output');
                $this->session->set_flashdata('success', 'Xuất dữ liệu thành công.');
                redirect(base_url('backend/home/index'));
                die();
            } else {
                $this->session->set_flashdata('error', 'Không có dữ liệu nào được xuất ra Excel.');
                redirect(base_url('backend/home/index'));
            }
        } catch (Exception $e) {
            $this->session->set_flashdata('error', 'Xuất dữ liệu không thành công.');
            redirect(base_url('backend/home/index'));
        }
    }


} 