<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class Mcontest_details extends CI_Model
{
    protected $_table = 'contest_details';

    public function __construct()
    {
        parent::__construct();
        date_default_timezone_set("Asia/Ho_Chi_Minh");
    }

    public function add($dataInsert)
    {
        $this->db->insert($this->_table, $dataInsert);
        $insert_id = $this->db->insert_id();
        return $insert_id;
    }

    public function update($id, $dataUpdate)
    {
        try {
            $this->db->where('id', $id);
            $this->db->update($this->_table, $dataUpdate);
            return true;
        } catch (Exception $e) {
            return false;
        }
    }

    public function getById($id)
    {
        $this->db->select($this->_table . '.*');
        $this->db->from($this->_table);
        $this->db->where($this->_table . '.id', $id);
        $query = $this->db->get();
        return $query->result_array();
    }

    public function getListForSelectBox()
    {
        $this->db->select('id, fullname, username, sid');
        $this->db->from($this->_table);
        $this->db->where('sid !=', '');
        $this->db->order_by($this->_table . '.username', 'asc');
        $query = $this->db->get();
        return $query->result_array();
    }

    /**
     * Lay cuoc thi hien hanh
     * @return mixed
     */
    public function getDateOrderByToday()
    {
        $this->db->select($this->_table . '.*');
        $this->db->from($this->_table);
        $this->db->where('DATE(date_play)', date('Y-m-d'));
        $this->db->limit(1);
        $query = $this->db->get();
        return $query->result_array();
    }

    public function getByDateOrder($date_order){
        $this->db->select('*');
        $this->db->from($this->_table);
        $this->db->where('date_order', $date_order);
        $this->db->limit(1);
        $query = $this->db->get();
        return $query->result_array();
    }


}

/* End of file welcome.php */
/* Location: ./application/controllers/welcome.php */