<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Mgame extends CI_Model {
    protected $_table='game';

    public function __construct(){
        parent::__construct();
        date_default_timezone_set("Asia/Ho_Chi_Minh");
    }

    public function add($dataInsert){
        $this->db->insert($this->_table, $dataInsert);
        $insert_id = $this->db->insert_id();
        return $insert_id;
    }

    public function update($id, $dataUpdate){
        $this->db->where('id', $id);
        $this->db->update($this->_table, $dataUpdate);
    }

    public function getById($id){
        $this->db->select($this->_table.'.*');
        $this->db->from($this->_table);
        $this->db->where($this->_table.'.id', $id);
        $query = $this->db->get();
        return $query->result_array();
    }

    /**
     * Lay thong tin Game theo UserId
     * @param $user_id
     * @return mixed
     */
    public function getByUserId($user_id){
        $this->db->select($this->_table.'.*');
        $this->db->from($this->_table);
        $this->db->where($this->_table.'.user_id', $user_id);
        $query = $this->db->get();
        return $query->result_array();
    }

    public function getResultByUserId($user_id){
        $this->db->select('g.*, u.fullname, u.username, u.email, u.token');
        $this->db->from($this->_table.' g');
        $this->db->join('user u', 'u.id = g.user_id', 'left');
        $this->db->where('g.user_id', $user_id);
        $this->db->limit(1);
        $query = $this->db->get();
        return $query->result_array();
    }

    public function getFullnameById($id){
        $this->db->select($this->_table.'.fullname');
        $this->db->from($this->_table);
        $this->db->where($this->_table.'.id', $id);
        $this->db->limit(1);
        $query = $this->db->get();
        $arr = array();
        $arr = $query->result_array();
        return $arr[0]['fullname'];

    }

    public function cmsCountAll($name=null){
        $this->db->select('COUNT(*) AS totalResults');
        $this->db->from($this->_table);
        if($name != null){
            $this->db->like('fullname', $name, 'both');
            $this->db->or_like('username', $name, 'both');
            $this->db->or_like('address', $name, 'both');
            $this->db->or_like('email', $name, 'both');
            $this->db->or_like('mobile', $name, 'both');
            $this->db->or_like('reward_code', $name, 'both');
        }
        $query = $this->db->get();
        $result = $query->result_array();
        if($result){
            return $result[0]['totalResults'];
        }else{
            return 0;
        }
    }

    public function cmsGetPagination($record, $start, $name=null){
        $this->db->select($this->_table.'.*');
        $this->db->from($this->_table);
        if($name != null){
            $this->db->like($this->_table.'.fullname', $name, 'both');
            $this->db->or_like('username', $name, 'both');
            $this->db->or_like('address', $name, 'both');
            $this->db->or_like('email', $name, 'both');
            $this->db->or_like('mobile', $name, 'both');
            $this->db->or_like('reward_code', $name, 'both');
        }
        $this->db->order_by($this->_table.'.created_at', 'desc');
        $this->db->limit($record, $start);
        $query = $this->db->get();
        return $query->result_array();
    }

    public function getListForSelectBox(){
        $this->db->select('id, fullname, username, sid');
        $this->db->from($this->_table);
        $this->db->where('sid !=', '');
        $this->db->order_by($this->_table.'.username', 'asc');
        $query = $this->db->get();
        return $query->result_array();
    }

}

/* End of file welcome.php */
/* Location: ./application/controllers/welcome.php */