<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class Mlink_clicked extends CI_Model
{
    protected $_table = 'link_clicked';

    public function __construct()
    {
        parent::__construct();
        date_default_timezone_set("Asia/Ho_Chi_Minh");
    }

    public function add($dataInsert)
    {
        $this->db->insert($this->_table, $dataInsert);
        $insert_id = $this->db->insert_id();
        return $insert_id;
    }

    public function update($id, $dataUpdate)
    {
        try {
            $this->db->where('id', $id);
            $this->db->update($this->_table, $dataUpdate);
            return true;
        } catch (Exception $e) {
            return false;
        }
    }

    public function cmsCountAll($name=null){
        $this->db->select('COUNT(*) AS totalResults');
        $this->db->from($this->_table.' lc');
        $this->db->join('user u', 'u.id = lc.user_id');
        if($name != null){
            $this->db->like('u.fullname', $name, 'both');
            $this->db->or_like('u.username', $name, 'both');
            $this->db->or_like('u.address', $name, 'both');
            $this->db->or_like('u.email', $name, 'both');
            $this->db->or_like('u.mobile', $name, 'both');
            $this->db->or_like('u.reward_code', $name, 'both');
            $this->db->or_like('lc.link', $name, 'both');
        }
        $query = $this->db->get();
        $result = $query->result_array();
        if($result){
            return $result[0]['totalResults'];
        }else{
            return 0;
        }
    }

    public function cmsGetPagination($record, $start, $name=null){
        $this->db->select('lc.*, u.fullname, u.username, u.email, u.mobile, u.reward_code');
        $this->db->from($this->_table.' lc');
        $this->db->join('user u', 'u.id = lc.user_id', 'left');
        if($name != null){
            $this->db->like('u.fullname', $name, 'both');
            $this->db->or_like('u.username', $name, 'both');
            $this->db->or_like('u.address', $name, 'both');
            $this->db->or_like('u.email', $name, 'both');
            $this->db->or_like('u.mobile', $name, 'both');
            $this->db->or_like('u.reward_code', $name, 'both');
            $this->db->or_like('lc.link', $name, 'both');
        }
        $this->db->order_by('lc.created_at', 'desc');
        $this->db->limit($record, $start);
        $query = $this->db->get();
        return $query->result_array();
    }

}

/* End of file welcome.php */
/* Location: ./application/controllers/welcome.php */